
#property copyright ""
#property link      ""

#property indicator_separate_window
#property indicator_minimum -45.0
#property indicator_maximum 45.0
#property indicator_buffers 4
#property indicator_color1 DarkOrange
#property indicator_color2 Gray
#property indicator_color3 Red
#property indicator_color4 Blue

#property  indicator_width1  1
#property  indicator_width2  1
#property  indicator_width3  1
#property  indicator_width4  1

#property indicator_level2 12.0
#property indicator_level3 -12.0

extern string TimeFrame = "Current time frame";
extern int Per =120;
extern int Ma_Type=0;
extern int PRICE = 4;

extern int Level =15;

//////////////////////////////////////////

extern int Per1 =12;
extern int Ma_Type1=0;
extern int PRICE1 = 4;

extern int Level1=5;

///////////////////////////////////////////



extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

double AboveBuff[];
double ShortBuff[];
double LongBuffe[];
double BelowBuff[];

double AboveBuff1[];
double ShortBuff1[];
double LongBuffe1[];
double BelowBuff1[];
int    timeFrame;

// ---
int init() 
{
   IndicatorBuffers(8);
   SetIndexBuffer(0, ShortBuff);  SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0, 108); // Red
   SetIndexBuffer(1, LongBuffe);  SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1, 108); // Blue
   SetIndexBuffer(2, ShortBuff1); SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2, 111); // Red
   SetIndexBuffer(3, LongBuffe1); SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3, 111); // Blue
   SetIndexBuffer(4, AboveBuff);                       
   SetIndexBuffer(5, BelowBuff);  
   SetIndexBuffer(6, AboveBuff1);                        
   SetIndexBuffer(7, BelowBuff1);
   SetIndexLabel(0, "Trend Bullish");
   SetIndexLabel(1, "Trend Bearish");   
   SetIndexLabel(2, "Trend1 Bullish");  
   SetIndexLabel(3, "Trend1 Bearish");  
   
   SetLevelStyle(STYLE_DOT, 0, SteelBlue);
   timeFrame = stringToTimeFrame(TimeFrame);
   IndicatorShortName(timeFrameToString(timeFrame)+" Similar Duo to Fx MTN ");
   return (0);
}
	 	    			  		  		   		 	 	 	 	 		 						 	   				  	   	 		 			  			  	     		  	 			   	 	     			 	 		 		     			 	 	  		 	  		   			 			    	
// ---
int deinit()
{
   Comment("");
   
return(0);
}
		    			 	 			 	 	  	  		  	   	 				 			     		 	 	 	 		 	 	 	 	 		 		 		  	    					   		  	    	 					 	  	    	 			 	 	 		 	 	  	 	   	  	 	
// ---
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMax(Bars-counted_bars,3*timeFrame/Period());
   
   //
   //
   //
   //
   //
     
   for (int i = limit; i >=0; i--) 
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         double Main1 =iMA(NULL,timeFrame,Per1,0,Ma_Type1,PRICE1,y) ;     
         double Minr1 = 0.2 * iATR(NULL,timeFrame,Per1,y);
         
            if (Minr1!=0)
            {
               AboveBuff1[i] = 3.0 * (High[i]  - Main1) / Minr1;
               BelowBuff1[i] = 3.0 * (Low[i]   - Main1) / Minr1;
            }               
                       
          
            ShortBuff1[i] = EMPTY_VALUE;
            LongBuffe1[i] = EMPTY_VALUE;
            if (AboveBuff1[i] >  Level1) ShortBuff1[i] =  Level1+1;
            if (BelowBuff1[i] < -Level1) LongBuffe1[i] = -(Level1+1);
            
            double Main = iMA(NULL,timeFrame,Per,0,Ma_Type,PRICE,y) ;
            double Minr = 0.2 * iATR(NULL,timeFrame,Per,y);
         
            if (Minr!=0)
            {
               AboveBuff[i] = 3.0 * (High[i]  - Main) / Minr;
               BelowBuff[i] = 3.0 * (Low[i]   - Main) / Minr;
            }    
                       
            ShortBuff[i] = EMPTY_VALUE;
            LongBuffe[i] = EMPTY_VALUE;
            if (AboveBuff[i] >  Level) ShortBuff[i] =  Level+1;
            if (BelowBuff[i] < -Level) LongBuffe[i] = -(Level+1);
                              
      }
   manageAlerts();
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (ShortBuff[whichBar] != EMPTY_VALUE || LongBuffe[whichBar] != EMPTY_VALUE)
      {
         if (ShortBuff[whichBar] !=  EMPTY_VALUE) doAlert(whichBar,"Trend down");
         if (LongBuffe[whichBar] !=  EMPTY_VALUE) doAlert(whichBar,"Trend up");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," SimilarFxMNT Signal ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," SimilarFxMNT "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}


